searchData={"content_type":"text/markdown","items":[{"doc":"This module parse and validate arguments.","ref":"DoIt.Argument.html","title":"DoIt.Argument","type":"module"},{"doc":"","ref":"DoIt.Argument.html#parse_input/2","title":"DoIt.Argument.parse_input/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition/1","title":"DoIt.Argument.validate_definition/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_allowed_values/1","title":"DoIt.Argument.validate_definition_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_description/1","title":"DoIt.Argument.validate_definition_description/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_name/1","title":"DoIt.Argument.validate_definition_name/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_type/1","title":"DoIt.Argument.validate_definition_type/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input/2","title":"DoIt.Argument.validate_input/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_allowed_values/1","title":"DoIt.Argument.validate_input_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_allowed_values/2","title":"DoIt.Argument.validate_input_allowed_values/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_value/1","title":"DoIt.Argument.validate_input_value/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_value/2","title":"DoIt.Argument.validate_input_value/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#t:t/0","title":"DoIt.Argument.t/0","type":"type"},{"doc":"DoIt helper functions.","ref":"DoIt.Helper.html","title":"DoIt.Helper","type":"module"},{"doc":"Validates if all allowed values are of the same type.","ref":"DoIt.Helper.html#validate_list_type/2","title":"DoIt.Helper.validate_list_type/2","type":"function"},{"doc":"iex> DoIt.Helper.validate_list_type([0, 1, 2, 3], :integer)\n    true\n\n    iex> DoIt.Helper.validate_list_type([0, 1, 2.1, 3], :integer)\n    false\n\n    iex> DoIt.Helper.validate_list_type([0.1, 1.1, 2.1, 3.1], :float)\n    true\n\n    iex> DoIt.Helper.validate_list_type([0.1, 1.1, 2, 3.1], :float)\n    false\n\n    iex> DoIt.Helper.validate_list_type([\"warn\", \"error\", \"info\", \"debug\"], :string)\n    true\n\n    iex> DoIt.Helper.validate_list_type([\"warn\", \"error\", \"info\", 0], :string)\n    false\n\n    iex> DoIt.Helper.validate_list_type([\"warn\", \"error\", \"info\", \"debug\"], :unknown)\n    false","ref":"DoIt.Helper.html#validate_list_type/2-examples","title":"Examples - DoIt.Helper.validate_list_type/2","type":"function"},{"doc":"This module parse and validate options.","ref":"DoIt.Option.html","title":"DoIt.Option","type":"module"},{"doc":"","ref":"DoIt.Option.html#default/2","title":"DoIt.Option.default/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#default_filter/1","title":"DoIt.Option.default_filter/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#default_map/2","title":"DoIt.Option.default_map/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#group/1","title":"DoIt.Option.group/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#parse_input/2","title":"DoIt.Option.parse_input/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition/1","title":"DoIt.Option.validate_definition/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_alias/1","title":"DoIt.Option.validate_definition_alias/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_allowed_values/1","title":"DoIt.Option.validate_definition_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_default/1","title":"DoIt.Option.validate_definition_default/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_description/1","title":"DoIt.Option.validate_definition_description/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_keep/1","title":"DoIt.Option.validate_definition_keep/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_name/1","title":"DoIt.Option.validate_definition_name/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_type/1","title":"DoIt.Option.validate_definition_type/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input/2","title":"DoIt.Option.validate_input/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_allowed_values/1","title":"DoIt.Option.validate_input_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_allowed_values/2","title":"DoIt.Option.validate_input_allowed_values/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_value/1","title":"DoIt.Option.validate_input_value/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_value/2","title":"DoIt.Option.validate_input_value/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#t:t/0","title":"DoIt.Option.t/0","type":"type"},{"doc":"This module formats command help outputs.","ref":"DoIt.Output.html","title":"DoIt.Output","type":"module"},{"doc":"It returns the allowed values from the given `DoIt.Argument`.","ref":"DoIt.Output.html#format_argument_allowed_values/1","title":"DoIt.Output.format_argument_allowed_values/1","type":"function"},{"doc":"iex> DoIt.Output.format_argument_allowed_values(%DoIt.Argument{name: :op, type: :string, description: \"Operation\", allowed_values: [\"+\", \"-\", \"*\", \"/\"]})\n    \" (Allowed Values: \\\"+\\\", \\\"-\\\", \\\"*\\\", \\\"/\\\")\"\n\n    iex> DoIt.Output.format_argument_allowed_values(%DoIt.Argument{name: :verbose, type: :boolean, description: \"Makes the command verbose\"})\n    \"\"\n\n    iex> DoIt.Output.format_argument_allowed_values(%DoIt.Argument{name: :number, type: :integer, description: \"Numerical digit\", allowed_values: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]})\n    \" (Allowed Values: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9)\"","ref":"DoIt.Output.html#format_argument_allowed_values/1-examples","title":"Examples - DoIt.Output.format_argument_allowed_values/1","type":"function"},{"doc":"It returns the description from `DoIt.Argument`.","ref":"DoIt.Output.html#format_argument_description/1","title":"DoIt.Output.format_argument_description/1","type":"function"},{"doc":"iex> DoIt.Output.format_argument_description(%DoIt.Argument{name: :verbose, type: :boolean, description: \"Makes the command verbose\"})\n    \"Makes the command verbose\"","ref":"DoIt.Output.html#format_argument_description/1-example","title":"Example - DoIt.Output.format_argument_description/1","type":"function"},{"doc":"It formats the given `DoIt.Argument` name attribute with spaces on the right, accordingly with the `align` parameter.","ref":"DoIt.Output.html#format_argument_name/2","title":"DoIt.Output.format_argument_name/2","type":"function"},{"doc":"iex> DoIt.Output.format_argument_name(%DoIt.Argument{name: :verbose, type: :boolean, description: \"Makes the command verbose\"}, 15)\n    \"verbose        \"","ref":"DoIt.Output.html#format_argument_name/2-examples","title":"Examples - DoIt.Output.format_argument_name/2","type":"function"},{"doc":"It formats the given `DoIt.Option` alias attribute.","ref":"DoIt.Output.html#format_option_alias/1","title":"DoIt.Output.format_option_alias/1","type":"function"},{"doc":"iex> DoIt.Output.format_option_alias(%DoIt.Option{name: :help, type: :boolean, description: \"Shows the help command\", alias: nil})\n    \"   \"\n\n    iex> DoIt.Output.format_option_alias(%DoIt.Option{name: :help, type: :boolean, description: \"Shows the help command\", alias: :h})\n    \"-h,\"","ref":"DoIt.Output.html#format_option_alias/1-examples","title":"Examples - DoIt.Output.format_option_alias/1","type":"function"},{"doc":"It returns the allowed values from the given `DoIt.Option`.","ref":"DoIt.Output.html#format_option_allowed_values/1","title":"DoIt.Output.format_option_allowed_values/1","type":"function"},{"doc":"iex> DoIt.Output.format_option_allowed_values(%DoIt.Option{name: :op, type: :string, description: \"Operation\", allowed_values: [\"+\", \"-\", \"*\", \"/\"]})\n    \" (Allowed Values: \\\"+\\\", \\\"-\\\", \\\"*\\\", \\\"/\\\")\"\n\n    iex> DoIt.Output.format_option_allowed_values(%DoIt.Option{name: :verbose, type: :boolean, description: \"Makes the command verbose\"})\n    \"\"\n\n    iex> DoIt.Output.format_option_allowed_values(%DoIt.Option{name: :number, type: :integer, description: \"Numerical digit\", allowed_values: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]})\n    \" (Allowed Values: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9)\"","ref":"DoIt.Output.html#format_option_allowed_values/1-examples","title":"Examples - DoIt.Output.format_option_allowed_values/1","type":"function"},{"doc":"It formats the given `DoIt.Option` default attribute.","ref":"DoIt.Output.html#format_option_default/1","title":"DoIt.Output.format_option_default/1","type":"function"},{"doc":"iex> DoIt.Output.format_option_default(%DoIt.Option{name: :log_level, type: :string, description: \"Set the logging level\", alias: nil, default: \"warn\"})\n    \" (Default: \\\"warn\\\")\"\n\n    iex> DoIt.Output.format_option_default(%DoIt.Option{name: :skip_lines, type: :integer, description: \"Lines to skip\", alias: nil, default: 10})\n    \" (Default: 10)\"\n\n    iex> DoIt.Output.format_option_default(%DoIt.Option{name: :help, type: :boolean, description: \"Shows the help command\", alias: nil})\n    \"\"","ref":"DoIt.Output.html#format_option_default/1-examples","title":"Examples - DoIt.Output.format_option_default/1","type":"function"},{"doc":"It returns the description from `DoIt.Option`.","ref":"DoIt.Output.html#format_option_description/1","title":"DoIt.Output.format_option_description/1","type":"function"},{"doc":"iex> DoIt.Output.format_option_description(%DoIt.Option{name: :help, type: :boolean, description: \"Shows the help command\", alias: nil})\n    \"Shows the help command\"","ref":"DoIt.Output.html#format_option_description/1-examples","title":"Examples - DoIt.Output.format_option_description/1","type":"function"},{"doc":"It formats the given `DoIt.Option` name attribute with spaces on the right, accordingly with the `align` parameter.","ref":"DoIt.Output.html#format_option_name/2","title":"DoIt.Output.format_option_name/2","type":"function"},{"doc":"iex> DoIt.Output.format_option_name(%DoIt.Option{name: :help, type: :boolean, description: \"Shows the help command\", alias: nil}, 10)\n    \"--help      \"\n\n    iex> DoIt.Output.format_option_name(%DoIt.Option{name: :log_level, type: :string, description: \"Set the logging level\", alias: nil}, 12)\n    \"--log-level   \"","ref":"DoIt.Output.html#format_option_name/2-examples","title":"Examples - DoIt.Output.format_option_name/2","type":"function"},{"doc":"It gets the length of the longer name attribute.","ref":"DoIt.Output.html#longer_name/1","title":"DoIt.Output.longer_name/1","type":"function"},{"doc":"iex> DoIt.Output.longer_name([%{name: \"great\"}, %{name: \"greatest\"}])\n    8\n\n    iex> DoIt.Output.longer_name([%{name: \"Elixir\"}, %{name: \"Erlang\"}, %{name: \"DoIt\"}, %{name: \"OTP\"}])\n    6","ref":"DoIt.Output.html#longer_name/1-examples","title":"Examples - DoIt.Output.longer_name/1","type":"function"},{"doc":"","ref":"DoIt.Output.html#print_errors/1","title":"DoIt.Output.print_errors/1","type":"function"},{"doc":"","ref":"DoIt.Output.html#print_help/1","title":"DoIt.Output.print_help/1","type":"function"},{"doc":"","ref":"DoIt.Output.html#print_invalid_options/2","title":"DoIt.Output.print_invalid_options/2","type":"function"},{"doc":"Initializes DoIt persistent configuration.","ref":"Mix.Tasks.DoIt.Config.Init.html","title":"mix do_it.config.init","type":"task"},{"doc":"$ mix do_it.config.init","ref":"Mix.Tasks.DoIt.Config.Init.html#module-examples","title":"Examples - mix do_it.config.init","type":"task"},{"doc":"It shows a problem with an argument definition.","ref":"DoIt.ArgumentDefinitionError.html","title":"DoIt.ArgumentDefinitionError","type":"exception"},{"doc":"It shows a problem with a command definition.","ref":"DoIt.CommandDefinitionError.html","title":"DoIt.CommandDefinitionError","type":"exception"},{"doc":"It shows a problem with the initialization of the persistent configuration.","ref":"DoIt.InitConfigError.html","title":"DoIt.InitConfigError","type":"exception"},{"doc":"It shows a problem with the main command definition.","ref":"DoIt.MainCommandDefinitionError.html","title":"DoIt.MainCommandDefinitionError","type":"exception"},{"doc":"It shows a problem with an option definition.","ref":"DoIt.OptionDefinitionError.html","title":"DoIt.OptionDefinitionError","type":"exception"},{"doc":"[![Build Status](https://github.com/rzcastilho/do_it/workflows/CI/badge.svg)](https://github.com/rzcastilho/do_it/actions) [![Hex.pm](https://img.shields.io/hexpm/v/do_it.svg)](https://hex.pm/packages/do_it) [![Coverage Status](https://coveralls.io/repos/github/rzcastilho/do_it/badge.svg)](https://coveralls.io/github/rzcastilho/do_it) [![Documentation](https://img.shields.io/badge/documentation-gray)](https://hexdocs.pm/do_it/)\n\n# Do It\n\nElixir Command Line Interface Library.\n\nA library that helps to develop CLI tools with Elixir.","ref":"readme.html","title":"README","type":"extras"},{"doc":"The package can be installed by adding `do_it` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:do_it, \"~> 0.6\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - README","type":"extras"},{"doc":"**_Do It_** have two main components:\n\n  * `DoIt.Command` - represents a single command.\n  * `DoIt.MainCommand` - the entrypoint of the application where you declare all the commands, must be used as `main_module` in `escript` definition.\n  \nThe commands `version` and `help` are automatic generated for the client.\n\nThe version number is obtained from `mix.exs` or option `version` in `MainCommand`.\n\nSo, if you have a client named `cli`, you can type `cli version` and `cli help` to get the version number and the list of commands respectively from the client.\n\n#","ref":"readme.html#usage","title":"Usage - README","type":"extras"},{"doc":"It's the entrypoint of your CLI, it generates functions matching all declared commands in that module, delegating the call to the matched command.\n\nA `MainCommand` could be defined as follows:\n\n```elixir\ndefmodule HelloWorld do\n  use DoIt.MainCommand,\n    description: \"HelloWorld CLI\"\n\n  command(HelloWorld.Say)\n  command(HelloWorld.Template)\nend\n```\n\n#","ref":"readme.html#maincommand","title":"MainCommand - README","type":"extras"},{"doc":"We can define a new command as follows:\n\n```elixir\ndefmodule HelloWorld.Say do\n  use DoIt.Command,\n    description: \"Say something!!!\"\n\n  argument(:message, :string, \"Hello message\")\n\n  option(:template, :string, \"Message template\", alias: :t)\n\n  def run(%{message: message}, %{template: template}, _) do\n    hello(message, template)\n  end\n\n  def run(%{message: message}, _, %{config: %{\"default_template\" => template}}) do\n    hello(message, template)\n  end\n\n  def run(_, _, context) do\n    IO.puts(\"Pass a template s parameter or define a default template using template set command\")\n    help(context)\n  end\n\n  defp hello(message, template) do\n    IO.puts(EEx.eval_string(template, assigns: [message: message]))\n  end\nend\n\n```\n\nA `help` option is automatically added to the command to describe its usage.\n\n```shell\n$ ./hello_world say --help\n\nUsage: hello_world say [OPTIONS]  \n\nSay something!!!\n\nArguments:\n  message   Hello message\n\nOptions:\n      --help       Print this help\n  -t, --template   Message template\n```\n\nUse `DoIt.Command` and provide a required `description`, the command name is the module name, you can override that name using the `name` option.\n\n```elixir\ndefmodule Hello do\n  use DoIt.Command,\n    name: \"olleh\",\n    description: \"Useless hello command\"\n\n  ...\n\nend\n```\n\nYou can declare subcommands in a command to group them logically using the `subcommand` macro.\n\n```elixir\ndefmodule HelloWorld.Template do\n  use DoIt.Command,\n    description: \"Manage HelloWorld Template\"\n\n  subcommand(HelloWorld.Template.Set)\n  subcommand(HelloWorld.Template.Unset)\n  subcommand(HelloWorld.Template.Show)\nend\n```","ref":"readme.html#command","title":"Command - README","type":"extras"},{"doc":"There are two ways to generate the binaries.\n\n- [escript](https://hexdocs.pm/mix/Mix.Tasks.Escript.Build.html)\n- [burrito-elixir](https://github.com/burrito-elixir/burrito)\n\n#","ref":"readme.html#package","title":"Package - README","type":"extras"},{"doc":"To generate an application using the escript, you have to add a `:escript` key with the `:main_module` option to your project properties in your `mix.exs` file.\n\nThe `:main_module` is the module that you defined as `DoIt.MainCommand`.\n\n```elixir\n...\n  def project do\n    [\n      app: :hello_world,\n      version: \"0.1.0\",\n      elixir: \"~> 1.14\",\n      start_permanent: Mix.env() == :prod,\n      deps: deps(),\n      escript: [main_module: Cli]\n    ]\n  end\n...\n```\n\nBuild the binary running the mix task bellow.\n\n```shell\n$ mix escript.build\n==> do_it\nCompiling 4 files (.ex)\nGenerated do_it app\n==> hello_world\nCompiling 1 file (.ex)\nGenerated escript hello_world with MIX_ENV=dev\n```\n\nA binary with the application name will be generated in the project root.\n\n```shell\n$ ./hello_world help                                                                                                                                                     ─╯\n\nUsage: hello_world COMMAND\n\nMy useless CLI\n\nCommands:\n  say     Useless hello command\n```\n\n#","ref":"readme.html#escript","title":"escript - README","type":"extras"},{"doc":"> ##","ref":"readme.html#burrito-elixir","title":"burrito-elixir - README","type":"extras"},{"doc":">\n> See the elixir-burrito [readme](https://github.com/burrito-elixir/burrito) about some limitations and other configurations.\n\nTo configure the application to use the `burrito-elixir` you have to add the `burrito-elixir` dependency in your project, add the `:mod` property in the `application` function, and the `:releases` key with the releases configuration to your project properties in you `mix.exs` file.\n\nThe `:mod` property value is the module that you defined as `DoIt.MainCommand`.\n\n```elixir\ndefmodule CoinGeckoCli.MixProject do\n  use Mix.Project\n\n  def project do\n    [\n      app: :coin_gecko_cli,\n      version: \"0.1.0\",\n      elixir: \"~> 1.14\",\n      start_permanent: Mix.env() == :prod,\n      deps: deps(),\n      releases: releases()\n    ]\n  end\n\n  # Run \"mix help compile.app\" to learn about applications.\n  def application do\n    [\n      extra_applications: [:logger],\n      mod: {CoinGeckoCli, []}\n    ]\n  end\n\n  # Run \"mix help deps\" to learn about dependencies.\n  defp deps do\n    [\n      {:tesla, \"~> 1.7\"},\n      {:jason, \"~> 1.4\"},\n      {:do_it, \"~> 0.4\"},\n      {:burrito, github: \"burrito-elixir/burrito\"},\n      {:tableize, \"~> 0.1.0\"}\n    ]\n  end\n\n  def releases do\n    [\n      coin_gecko_cli: [\n        steps: [:assemble, &Burrito.wrap/1],\n        burrito: [\n          targets: [\n            macos: [os: :darwin, cpu: :x86_64],\n            linux: [os: :linux, cpu: :x86_64],\n            windows: [os: :windows, cpu: :x86_64]\n          ],\n        ]\n      ]\n    ]\n  end\nend\n```\n\nGenerate the binaries using the mix task bellow, a binary of each target will be generated in the `burrito_out` folder of your root application.\n\n```shell\n$ MIX_ENV=prod mix release\n...\n...\n...\n$ cd burrito_out\n$ ls -c1                                                                                                                                                                 ─╯\ncoin_gecko_cli_linux\ncoin_gecko_cli_macos\ncoin_gecko_cli_windows\n\n$ ./coin_gecko_cli_linux help                                                                                                                                            ─╯\n\nUsage: coin_gecko_cli COMMAND\n\nCoinGecko CLI\n\nCommands:\n  list     List assets\n```","ref":"readme.html#experimental-warning","title":"Experimental {: .warning} - README","type":"extras"},{"doc":"DoIt is released under the Apache License 2.0 - see the [LICENSE](LICENSE) file.","ref":"readme.html#license","title":"License - README","type":"extras"},{"doc":"Copyright 2021 Rodrigo Zampieri Castilho  \n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]}